# The following macros can be changed.

%define disable_edg_prefix  1
%define install_flavor_libs 1
%define use_glite_include   0

%define _sysconfdir /etc

# Specify the type of RPM dependencies depending on which version og Globus is used
%define use_modular_globus 1

Name: voms
Version: 1.6.20
Release: 2ng
License: EU DataGrid Software License
URL: http://grid-auth.infn.it/

Source: %{name}-%{version}.tar.gz
Source1: voms_manpages-1.6.20.tar.gz
Source2: README.NorduGrid
Patch0: voms_noglobusopenssl-1.6.20.patch
Patch1: voms_openssl-0.9.8.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires: expat-devel
BuildRequires: mysql-devel

## Difficult to name on different distributions
#BuildRequires: libtool-ltdl-devel

%if %{use_modular_globus}
BuildRequires: globus_core
BuildRequires: globus_common
BuildRequires: globus_openssl-devel
BuildRequires: globus_gssapi_gsi-devel
BuildRequires: globus_gss_assist-devel
%else
BuildRequires: globus
%endif

Summary: Virtual Organization Membership Service
Group: Grid
Requires: expat
%if %{use_modular_globus}
Requires: globus_openssl
Requires: globus_gssapi_gsi
Requires: globus_gss_assist
%else
Requires: globus
%endif
Prefix: %{_prefix}
Prefix: %{_sysconfdir}
%description
VOMS - Virtual Organization Membership Service.

%package devel
Summary: Virtual Organization Membership Service
Group: Grid
Requires: voms
Prefix: %{_prefix}
%description devel
VOMS - Virtual Organization Membership Service.

%package clients
Summary: Virtual Organization Membership Service
Group: Grid
Requires: voms
%if %{use_modular_globus}
Requires: globus_openssl
Requires: globus_gssapi_gsi
Requires: globus_gss_assist
%else
Requires: globus
%endif
Prefix: %{_prefix}
%description clients
VOMS - Virtual Organization Membership Service.

%package server
Summary: Virtual Organization Membership Service
Group: Grid
Requires: voms
Requires: mysql
%if %{use_modular_globus}
Requires: globus_openssl
Requires: globus_gssapi_gsi
Requires: globus_gss_assist
%else
Requires: globus
%endif
Prefix: %{_prefix}
Prefix: %{_sysconfdir}
%description server
VOMS - Virtual Organization Membership Service.

%prep
%setup -q
%setup -a 1
%patch0 -p1
%patch1 -p1
cp -p %{SOURCE2} .

#
# Fixes that could go into patches. However they would probably have to be remade
# for every new upstream release since they touch Makefile.in's which changes often
#

# Fix build-doc bug
cd src/api/ccapi
for i in Makefile*; do
  cp -p $i $i.tmp
  sed 's/^all-local:.*/all-local:/' < $i.tmp > $i
  rm -f $i.tmp
done
cd ../../..

# Fix libexec hardwiring - fix broken --libexecdir configure option
for i in `find . -name Makefile.\* -exec grep -H ^libexecdir '{}' \;|cut -f1 -d:`; do
  cp -p $i $i.tmp
  sed 's/\(^libexecdir = \)\$(prefix)\/libexec/\1@libexecdir@/' < $i.tmp > $i
  rm -f $i.tmp
done

# Fix locations
#   $HOME/.edg -> $HOME/.voms
for i in project/acinclude.m4 configure; do
  cp -p $i $i.tmp
  sed -e 's/\(LOCATION_DIR.*\)"\$prefix"/\1""/g' -e 's/\(USER_DIR.*\)\.edg/\1.voms/g'  < $i.tmp > $i
  rm -f $i.tmp
done
#   <prefix>/etc/init.d -> /etc/init.d
#   <prefix>/etc -> /etc
#   <prefix>/etc/voms -> /etc/voms
for i in src/install/Makefile.am src/install/Makefile.in; do
  cp -p $i $i.tmp
  sed -e 's!^initdir = .*!initdir = /etc/init.d!' \
      -e 's!^defaultsysconfdir = .*!defaultsysconfdir = /etc!' \
      -e 's!^sysconfdir = .*!sysconfdir = /etc/voms!' < $i.tmp > $i
  rm -f $i.tmp
done

%build

# Detect Globus installation
# - Check GLOBUS_LOCATION variable
# - Otherwise see if $GLOBUS_LOCATION/bin is in the path
#   and use globus-makefile-header from globus_common to determine GLOBUS_LOCATION 

if test "x$GLOBUS_LOCATION" = "x"; then
  for p in  `echo $PATH |tr : ' '`; do
    if test -f $p/globus-makefile-header; then
      GLOBUS_LOCATION=`dirname $p`
      break
    fi
  done
fi

if test -d "$GLOBUS_LOCATION"; then
  :
else
  echo "GLOBUS_LOCATION not set or is not a directory"
  exit 1
fi

#
# Try to detect/guess Globus flavor
#

if test -d "$GPT_LOCATION"; then
  globus_flavor=`$GPT_LOCATION/sbin/gpt-flavor-configuration |grep '^[a-zA-Z0-9]*:'|cut -f1 -d:|tail -1`
else
  globus_flavor=`gpt-flavor-configuration |grep '^[a-zA-Z0-9]*:'|cut -f1 -d:|tail -1`
fi
if test "$globus_flavor" = ""; then
  echo "Globus flavor could not be guessed"
  exit 1
fi

./configure --prefix=%{_prefix} --libdir=%{_libdir} --libexecdir=%{_libexecdir} \
            --with-globus-location=$GLOBUS_LOCATION --with-globus-flavor=${globus_flavor} \
            --disable-docs
make

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# Install man pages
cd doc
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man1
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
for s in 1 8; do
for m in *.$s; do
  cp -p $m $RPM_BUILD_ROOT%{_mandir}/man$s/$m
done
done
cd ..

# Remove unwanted documentation
rm -fr $RPM_BUILD_ROOT%{_prefix}/share/doc

%if %{disable_edg_prefix}
rm -f $RPM_BUILD_ROOT%{_bindir}/edg-voms*
rm -f $RPM_BUILD_ROOT%{_sbindir}/edg-voms*
%endif

%if !%{install_flavor_libs}
rm -f $RPM_BUILD_ROOT%{_libdir}/lib*_*
%endif

%if %{use_glite_include}
%define voms_include_dir glite/security/voms
%endif
%if !%{use_glite_include}
%define voms_include_dir voms 
mv $RPM_BUILD_ROOT%{_includedir}/glite/security/voms $RPM_BUILD_ROOT%{_includedir}/%{voms_include_dir}
rm -rf $RPM_BUILD_ROOT%{_includedir}/glite
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc AUTHORS INSTALL LICENSE README
%doc README.NorduGrid
%{_sysconfdir}/vomses.template
%{_libdir}/libvomsapi*.so.0
%{_libdir}/libvomsapi*.so.0.0.0
%{_libdir}/libvomsc*.so.0
%{_libdir}/libvomsc*.so.0.0.0

%files clients
%defattr(-,root,root,-)
%{_bindir}/voms-proxy-destroy
%{_bindir}/voms-proxy-info
%{_bindir}/voms-proxy-init
%{_bindir}/voms-proxy-fake
%{_bindir}/voms-proxy-list
%{_mandir}/man1/voms-proxy-destroy.1*
%{_mandir}/man1/voms-proxy-info.1*
%{_mandir}/man1/voms-proxy-init.1*
%{_mandir}/man1/voms-proxy-fake.1*
%{_mandir}/man1/voms-proxy-list.1*

%if !%{disable_edg_prefix}
%{_bindir}/edg-voms-proxy-destroy
%{_bindir}/edg-voms-proxy-info
%{_bindir}/edg-voms-proxy-init
%{_bindir}/edg-voms-proxy-fake
%{_bindir}/edg-voms-proxy-list
%endif

%files server
%defattr(-,root,root,-)
%{_sbindir}/voms
%{_sysconfdir}/init.d/voms
%{_sysconfdir}/voms/voms.data
%{_libexecdir}/voms/mysql2oracle
%{_libexecdir}/voms/upgrade1to2
%{_libexecdir}/voms/voms_install_db
%{_libexecdir}/voms/test_clean
%{_libexecdir}/voms/test_setup
%{_libexecdir}/voms/test_start
%{_libexecdir}/voms/voms_install_replica
%{_mandir}/man1/voms_install_db.1*
%{_mandir}/man1/voms_install_replica.1*
%{_mandir}/man8/voms.8*
%if !%{disable_edg_prefix}
%{_sbindir}/edg-voms
%{_mandir}/man8/edg-voms.8*
%endif

%files devel
%defattr(-,root,root,-)
%{_includedir}/%{voms_include_dir}/acstack.h
%{_includedir}/%{voms_include_dir}/newformat.h
%{_includedir}/%{voms_include_dir}/voms_api.h
%{_includedir}/%{voms_include_dir}/voms_apic.h
%{_libdir}/libvomsapi*.a
%{_libdir}/libvomsapi*.la
%{_libdir}/libvomsapi*.so
%{_libdir}/libvomsc*.a
%{_libdir}/libvomsc*.la
%{_libdir}/libvomsc*.so
%if 0
%{_mandir}/man3/data.3*
%{_mandir}/man3/voms.3*
%{_mandir}/man3/voms_api.h.3*
%{_mandir}/man3/voms_apic.h.3*
%{_mandir}/man3/vomsdata.3*
%endif

%changelog
* Mon Jul 24 2006 Anders Waananen <waananen@nbi.dk> - 1.6.20-2ng
- Fix dependency typo: Requires -> BuildRequires
* Sat May  6 2006 Anders Waananen <waananen@nbi.dk> - 1.6.20-1ng
- Many changes since upstream changed quite a lot.
- Added README.NorduGrid with packaging information
- Patches:
  - voms_openssl-0.9.8.patch
    - Support for OpenSSL 0.9.8
  - voms_noglobusopenssl-1.6.20.patch
    - Use system openssl rather than the one from Globus
    - Patch reworked for voms 1.6.20
  - Dont use project based (gLite) include paths
- Pseudo patches (fixes made at runtime and not from static patch files)
  - Fix broken --libexecdir support for configure
    (some systems do not have libexecdir = <prefix>/libexec)
  - Drop all documents except man pages which are pre-generated
    (section 3 man pages are skipped as well)
  - Do not use edg- prefix
    (can be turned on/off through macro)
  - Install flavored libraries in addition to non-flavored
    (can be turned on/off through macro)
  - Put start-up script in /etc/init.d
  - Move configuration files from <prefix>/etc to /etc
* Mon Dec 19 2005 Anders Waananen <waananen@nbi.dk> - 1.6.9-2
- Add patch voms_doc.patch to disable html and ps documentation
  and add man-mages and pdf files to distribution (make dist)
- Use rpm switch: --define "_autotools_bootstrap 1" to rebuild documentation
  and create "make dist" target
- Add patch voms_nohardcodelibexecdir.patch which use the libexecdir
  from configure rather than the hardcoded prefix/libexec
* Sun Nov 27 2005 Anders Waananen <waananen@nbi.dk> - 1.6.9-1
- Add patch voms_ssl_include.patch to add external openssl includes.
  Would be better to query globus_openssl about this
* Tue Oct 18 2005 Anders Waananen <waananen@nbi.dk> - 1.6.7-1
- Modfiy voms_noglobusopenssl.patch to match upstream
- Add patch voms_nops.patch to disable postscript versions of reference manual
* Fri Jun 17 2005 Anders Waananen <waananen@nbi.dk> - 1.5.4-1
- Remove the following patches:
  - voms_namespace.patch - Fixed in upstream
  - voms_external_mysql++-1.4.1.patch - Obsolete since mysql++ is no longer needed
  - voms-no_libs.path - Fixed in upstream
- Add Globus dependencies
* Wed Jun  1 2005 Anders Waananen <waananen@nbi.dk> - 1.4.1-3
- Do not hardcode Globus flavor but try to guess
- Remove explicit globus rpm Requirement
- Use external openssl - not globus_openssl
* Mon May  2 2005 Anders Waananen <waananen@nbi.dk> - 1.4.1-2
- Remove automake cache
- Add explicit dependency on mysql++-devel
* Sat Apr 30 2005 Anders Waananen <waananen@nbi.dk> - 1.4.1-1
- New upstream
- autogen.sh -> autobuild.sh
* Mon Apr 18 2005 Anders Waananen <waananen@nbi.dk> - 1.3.2-1
- Initial build.
